/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package salidasautomaticas.mysqldao;

import java.sql.Connection;
import java.time.LocalDate;
import java.time.LocalTime;
import java.util.Iterator;
import org.json.JSONArray;
import org.json.JSONObject;
import salidasautomaticas.dao.SalidasDAO;
import salidasautomaticas.util.EstandarDAO;

/**
 *
 * @author sistem19user
 */
public class SalidasMysqlDAO implements SalidasDAO {

    @Override
    public JSONArray obtenerHorariosSalida() throws Exception {
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");
        int diaSemana = obtenerDiaSemana();
        String query = "SELECT {campo_salida} as salida FROM ("
                + "SELECT"
                + "	p.salidaLV, "
                + "	p.salidaS "
                + "FROM"
                + "	asistencia a "
                + "INNER JOIN personal p ON a.codper = p.codper "
                + "INNER JOIN salidas_update su ON p.codcargo = su.codcargo "
                + "WHERE "
                + "	a.fecha_asis BETWEEN '2018-04-03' AND '2018-04-05' "
                + "AND p.retirado = 0 " 
                + "AND p.horaing = su.horaLV "
                + "AND p.mining = su.minutoLV "
                + "AND p.horaingsabado = su.sabadoLV "
                + "AND p.miningsabado = su.sabadoS "
                + "AND NOT p.codlocal IN ('L035', 'L053', 'L038') "
                + "AND NOT p.pronoe = 1 "
                + "AND NOT p.codcargo IN (71, 13) "
                + "AND NOT p.horaing > 19 "
                + "AND NOT p.salidaS = '') as tabla WHERE NULLIF( {campo_salida} , '') is NOT null  GROUP BY {campo_salida} ";

        if (diaSemana >= 1 && diaSemana <= 5) {
            query = query.replaceAll("\\{campo_salida\\}", "tabla.salidaLV");
        } else if (diaSemana == 6) {
            query = query.replaceAll("\\{campo_salida\\}", "tabla.salidaS");
        }
        JSONArray jsonArray = EstandarDAO.getInstance().consultar(cn, query);

        return jsonArray;
    }

    private int obtenerDiaSemana() {
        int diaSemana;
        LocalDate date = LocalDate.now();
        diaSemana = date.getDayOfWeek().getValue();

        return diaSemana;
    }
    
    private String getFechaHoy(){
        String fechaHoy;
        LocalDate date = LocalDate.now();
        int anio = date.getYear();
        int mes = date.getMonthValue();
        int dia = date.getDayOfMonth();
   
        fechaHoy = String.format("%s-%02d-%02d", anio, mes, dia);
       
        
        return fechaHoy;
    }
    
    
    private String getFechaAyer(){
        String fechaAyer;
        LocalDate date = LocalDate.now();
        date.plusDays(-1);
        
        int anio = date.getYear();
        int mes = date.getMonthValue();
        int dia = date.getDayOfMonth();
        
        fechaAyer = String.format("%s-%02d-%02d", anio, mes, dia);
        
        return fechaAyer;
    }
    
    

    @Override
    public JSONArray obtenerAsistencias(String horaProgramada) throws Exception {
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");
        String query = "SELECT * from "
                + "(select "
                + "	asistencia.codasis, "
                + "asistencia.fecha_asis, "
                + "{campo_salida} as salida "
                + "FROM "
                + "	asistencia "
                + "INNER JOIN personal ON asistencia.codper = personal.codper "
                + "WHERE "
                + "	asistencia.horasal = '' "
                + "AND asistencia.minsal = '' "
                + "AND ( {campo_salida} <= ? AND asistencia.fecha_asis='{fecha_hoy}' "
                + "OR asistencia.fecha_asis BETWEEN '2018-03-17' AND '{fecha_ayer}') "
                + "AND {campo_salida} is not NULL  "
                + "AND NOT personal.codlocal IN ('L035', 'L053', 'L038') "
                + "AND NOT personal.codcargo IN (71, 13) "
                + "AND NOT personal.pronoe = 1 "
                + "AND (WEEKDAY(asistencia.fecha_asis) + 1) !=7 AND personal.retirado=0) as tabla "
                + "where tabla.salida!=''";

        String campoSalida = "("
                + "case "
                + "when (WEEKDAY(asistencia.fecha_asis) + 1)<6 then salidaLV "
                + "when (WEEKDAY(asistencia.fecha_asis) + 1)=6 then salidaS end "
                + ") ";

        query = query.replaceAll("\\{campo_salida\\}", campoSalida);
        query = query.replaceAll("\\{fecha_hoy\\}", getFechaHoy());
        query = query.replaceAll("\\{fecha_ayer\\}", getFechaAyer());
        
        
        JSONArray parametros = new JSONArray();
        parametros.put(horaProgramada);

        JSONArray jsonArray = EstandarDAO.getInstance().consultar(cn, query, parametros);

        return jsonArray;
    }

    @Override
    public JSONObject actualizarSalida() throws Exception {
        JSONObject resultado = null;
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");
        LocalTime horaSistema = LocalTime.now();
        int cantMinSistema = horaSistema.getHour() * 60 + horaSistema.getMinute();
        JSONArray listadoHoras = obtenerHorariosSalida();
        System.out.println("listadoHoras " + listadoHoras);
        for (Iterator iterator = listadoHoras.iterator(); iterator.hasNext();) {
            System.out.println("" + 1);
            int aleatorioHora = 0, aleatorioMin = 0;
            JSONObject objHora = (JSONObject) iterator.next();
            System.out.println("objHora " + objHora);
            String[] splitHora = objHora.getString("salida").split(":");
            int cantidadMin = Integer.parseInt(splitHora[0]) * 60 + Integer.parseInt(splitHora[1]);

            if (cantidadMin > cantMinSistema) {
                //Reprogramacion
                System.out.println("Me reprogramo");
            } else {
                System.out.println("Programo");
                JSONArray listadoProgramar = obtenerAsistencias(objHora.getString("salida"));
                System.out.println("listadoProgrmar " + listadoProgramar);
                for (Iterator iterator1 = listadoProgramar.iterator(); iterator1.hasNext();) {
                    JSONObject objPrograma = (JSONObject) iterator1.next();

                    String[] splitHoraConsulta = objPrograma.getString("salidaLV").split(":");
                    int min = Integer.parseInt(splitHoraConsulta[1]);
                    int hora = Integer.parseInt(splitHoraConsulta[0]);
                    System.out.println("obj " + objPrograma);
                    //Actualizacion de salidas
                    if (min == 0) {
                        aleatorioHora = (int) Math.floor(Math.random() * (hora - (hora - 1) + 1) + (hora - 1));
                    } else {
                        aleatorioHora = hora;
                    }
                    if (hora == aleatorioHora) {
                        if (min == 0) {
                            aleatorioMin = (int) Math.floor(Math.random() * (3 - 0 + 1) + 0);
                        } else {
                            aleatorioMin = (int) Math.floor(Math.random() * (33 - 27 + 1) + 27);
                        }
                    } else {
                        aleatorioMin = (int) Math.floor(Math.random() * (59 - 56 + 1) + 56);
                    }

                    String queryPersonal = "update asistencia set horasal= ?,minsal=? where codasis=? ";
                    JSONArray parametros = new JSONArray();
                    parametros.put(aleatorioHora);
                    parametros.put(aleatorioMin);
                    parametros.put(objPrograma.getString("codasis"));
//                    System.out.println("consulta "+queryPersonal+ " "+parametros);
                    resultado = EstandarDAO.getInstance().ejecutar(cn, queryPersonal, parametros);
                    System.out.println("Resultado updates =" + resultado);
                }
            }
        }

        return resultado;
    }

    @Override
    public JSONObject actualizarSalida(String horaSalida) throws Exception {
        JSONObject resultado = null;
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");

        int aleatorioHora = 0, aleatorioMin = 0;

        JSONArray listaAsistencias = obtenerAsistencias("17:00");

        System.out.println("lista de asistencias para actualizar " + horaSalida + " " + listaAsistencias);
        for (Iterator it = listaAsistencias.iterator(); it.hasNext();) {
            JSONObject asistencia = (JSONObject) it.next();
            
            String salidaPersonal = asistencia.getString("salida");
            
//            if(salidaPersonal==null || salidaPersonal.isEmpty()){      
//                continue;
//            }
            
            
            String[] splitHoraConsulta = salidaPersonal.split(":");
            int min = Integer.parseInt(splitHoraConsulta[1]);
            int hora = Integer.parseInt(splitHoraConsulta[0]);
            System.out.println("obj " + asistencia);
            //Actualizacion de salidas
            if (min == 0) {
                aleatorioHora = (int) Math.floor(Math.random() * (hora - (hora - 1) + 1) + (hora - 1));
            } else {
                aleatorioHora = hora;
            }
            if (hora == aleatorioHora) {
                if (min == 0) {
                    aleatorioMin = (int) Math.floor(Math.random() * (3 - 0 + 1) + 0);
                } else {
                    aleatorioMin = (int) Math.floor(Math.random() * (33 - 27 + 1) + 27);
                }
            } else {
                aleatorioMin = (int) Math.floor(Math.random() * (59 - 56 + 1) + 56);
            }

            String queryPersonal = "update asistencia set horasal= ?,minsal=? where codasis=? ";
            JSONArray parametros = new JSONArray();
            parametros.put(aleatorioHora);
            parametros.put(aleatorioMin);
            parametros.put(asistencia.getString("codasis"));
//                    System.out.println("consulta "+queryPersonal+ " "+parametros);
            resultado = EstandarDAO.getInstance().ejecutar(cn, queryPersonal, parametros);
            System.out.println("Asistencia actualizada");
        }

        return resultado;
    }
}
